/* cons.c   by Michael Thorpe   2009-05-19 */

#include <stdlib.h>
#include <string.h>
#include "lisp.h"

static obj *cons_tostring(obj *in) {
	obj *out=0,*tmp,**a;
	char *s;
	unsigned long i,l,n;
	int halfopen=0;

	for(i=0,tmp=in;tmp->type==&cons_objtype;tmp=tmp->value.c.d)
		i++;
	a=(obj **)malloc((i+1)*sizeof(obj *));
	if(!a) {
		DECREF(in);
		return(throwoom());
	}
	l=1; /*  2 (for the open/close parens)
	        -1 (for the "extra" space char on item 0) */
	n=0;
	tmp=in;
	while(tmp->type==&cons_objtype) {
		a[n]=(tmp->value.c.a->type->tostring)(INCREF(tmp->value.c.a));
		if(!a[n])
			goto fail;
		if(a[n]->type != &string_objtype) {
			throwtypeerror(a[n]);
			goto fail;
		}
		l += 1+a[n]->value.s.len; /* the 1 is for the separating space */
		n++;
		tmp=tmp->value.c.d;
	}
	if(tmp->type != &nil_objtype) {
		a[n]=(tmp->type->tostring)(INCREF(tmp));
		if(!a[n])
			goto fail;
		if(a[n]->type != &string_objtype) {
			throwtypeerror(a[n]);
			goto fail;
		}
		l += 3+a[n]->value.s.len; /* the 3 is for the " . " */
		n++;
		halfopen=1;
	}
	out=new_string(0,l);
	if(!out)
		goto fail;
	s=out->value.s.data;
	s[0]='(';
	l=1;
	for(i=0;i<n;i++) {
		if(i) {
			if(i+1 == n && halfopen) {
				s[l++]=' ';
				s[l++]='.';
			}
			s[l++]=' ';
		}
		memcpy(&s[l],a[i]->value.s.data,a[i]->value.s.len);
		l += a[i]->value.s.len;
	}
	s[l]=')';
fail:
	while(0<n--)
		DECREF(a[n]);
	free(a);
	DECREF(in);
	return(out);
}

static void decref_cons(obj *o) {
	DECREF(o->value.c.a);
	DECREF(o->value.c.d);
}

obj *cons(obj *a,obj *d) {
	obj *c;

	c=new_object(&cons_objtype);
	if(!c) {
		DECREF(a);
		DECREF(d);
		return(0);
	}
	c->value.c.a=a;
	c->value.c.d=d;
	return(c);
}

objtype cons_objtype={
	name: "cons",
	tostring: cons_tostring,
	dropobj: decref_cons
};

