/* throw.c   by Michael Thorpe   2009-05-19 */

#include "lisp.h"

static obj *access_error;
static obj *argument_error;
static obj *oom_error;
static obj *rangecheck_error;
static obj *type_error;

obj *exception,*exceptionvalue;

obj *throw(obj *type,obj *value) {
	DECREF(exception);
	DECREF(exceptionvalue);
	exception=type;
	exceptionvalue=value;
	return(0);
}

obj *throwaccesserror(obj *value) {
	return(throw(INCREF(access_error),value));
}

obj *throwargumenterror(obj *value) {
	return(throw(INCREF(argument_error),value));
}

obj *throwoom() {
	return(throw(INCREF(oom_error),INCREF(&nilobj)));
}

obj *throwrangecheck(obj *value) {
	return(throw(INCREF(rangecheck_error),value));
}

obj *throwtypeerror(obj *value) {
	return(throw(INCREF(type_error),value));
}

int throw_init() {
	if(!(access_error=new_word("access-error",12))
	|| !(argument_error=new_word("argument-error",14))
	|| !(oom_error=new_word("out-of-memory",13))
	|| !(rangecheck_error=new_word("rangecheck",10))
	|| !(type_error=new_word("type-error",10)))
		return(1);
	exception=INCREF(&nilobj);
	exceptionvalue=INCREF(&nilobj);
	return(0);
}

void throw_exit() {
	DECREF(access_error); access_error=0;
	DECREF(argument_error); argument_error=0;
	DECREF(oom_error); oom_error=0;
	DECREF(rangecheck_error); rangecheck_error=0;
	DECREF(type_error); type_error=0;
	DECREF(exception); exception=0;
	DECREF(exceptionvalue); exceptionvalue=0;
}
